﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text.RegularExpressions;
using System.Linq;

namespace Dante98_2_TextEditor
{
    public partial class Form1 : Form
    {
        class cls_Data
        {
            internal int position = 0;
            internal byte[] data = null;

            internal byte id = 0;
            internal byte len = 0; 
            internal byte id2 = 0;       

            internal bool IsHeader = false;

            internal bool IsText = false;
            internal string text_source = "";
            internal string text_replace = "";

            internal cls_Header header = null;
        }

        class cls_Header : cls_Data
        {
            //header--
            internal int total_size = 0;

            internal byte _x02_X = 0;
            internal byte _x03_Y = 0;
            internal byte _x07_unkown = 0;
            internal byte _x16_SeqNum = 0;

            internal ushort[] off_data = new ushort[4];
            internal ushort[] size_data = new ushort[4];
            internal List<cls_Data>[] datas = new List<cls_Data>[4];

            public override string ToString()
            {
                return string.Format("{0}:{1}",
                    _x16_SeqNum.ToString().PadLeft(2, '0'),
                    //_SIZE_data1.ToString().PadLeft(4, '0'),
                    position.ToString("X").PadLeft(4, '0'));
            }
        }

        class cls_MAPFile
        {
            internal string path = "";
            internal string title = "";
            internal string fileName = "";
        }

        string[] columns = new string[] { "OFF", "X:Y", "ID", "ID2","LEN",            
            "TEXT_RAW", "TEXT_ENG" };
        const int _JAP = 5;
        const int _ENG = 6;
        const int _ID = 2;

        const int MAX_TEXT_LENGTH = 53;

        List<cls_Data> g_texts = new List<cls_Data>();
        Encoding sjis = Encoding.GetEncoding(932);
        string current_file = "";
        List<cls_MAPFile> map_files = new List<cls_MAPFile>();
        string name_set = "Dante98_2_TextEditor.setting";

        ushort get_ushort(int off)
        {
            return BitConverter.ToUInt16(g_bits, off);
        }
        byte[] g_bits = null;
        cls_Header[] g_headers = null;
        compair compa = new compair();
        class compair : System.Collections.IComparer
        {
            int System.Collections.IComparer.Compare(object x, object y)
            {
                if (x == null && y == null)
                {
                    return 0;
                }

                if (x == null)
                {
                    return 1;
                }

                if (y == null)
                {
                    return -1;
                }

                cls_Header ccc = x as cls_Header;
                cls_Header fff = y as cls_Header;
                return ccc.position.CompareTo(fff.position);
            }
        }     

        object load()
        {
            FileStream fs = new FileStream(name_set,
                FileMode.Open,
                FileAccess.Read);
            BinaryFormatter f = new BinaryFormatter();
            object obj = f.Deserialize(fs);
            fs.Close();
            return obj;
        }

        void save(object obj)
        {
            FileStream fs = new FileStream(name_set,
                FileMode.Create,
                FileAccess.Write);
            BinaryFormatter bf = new BinaryFormatter();
            bf.Serialize(fs, obj);
            fs.Close();
        }
        private void btn_open_mapfiles_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "DAT_MAP|*.DAT";
            DialogResult dr = openFileDialog1.ShowDialog();
            if (dr != System.Windows.Forms.DialogResult.OK)
            {
                return;
            }

            get_files(Path.GetDirectoryName(openFileDialog1.FileName));
        }
        void get_files(string directory)
        {
            string[] files = Directory.GetFiles(directory, "*.DAT");
            if (files.Length == 0)
            {
                MessageBox.Show("map file is not found!");
                return;
            }

            map_files.Clear();

            foreach (string file_path in files)
            {
                byte[] bits = File.ReadAllBytes(file_path);

                int posi = 0x16;

                List<byte> names = new List<byte>();
                while (true)
                {
                    if (bits[posi] == 0)
                    {
                        break;
                    }
                    names.Add(bits[posi++]);
                }

                cls_MAPFile cls = new cls_MAPFile();
                cls.title = sjis.GetString(names.ToArray());
                cls.fileName = Path.GetFileNameWithoutExtension(file_path);
                cls.path = file_path;

                map_files.Add(cls);
            }

            dataGridView2.RowCount = map_files.Count;
        }
               

        public Form1()
        {
            InitializeComponent();

            //dataGridView1.Font = new System.Drawing.Font("ＭＳ ゴシック", 11f);
            dataGridView1.VirtualMode = true;

            foreach (string head in columns)
            {
                dataGridView1.Columns.Add(head, head);
            }

            dataGridView1.Columns[0].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
            dataGridView1.Columns[1].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
            dataGridView1.Columns[2].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
            dataGridView1.Columns[3].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
            dataGridView1.Columns[4].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;

            dataGridView1.Columns[0].Width = 50;
            dataGridView1.Columns[1].Width = 70;
            dataGridView1.Columns[2].Width = dataGridView1.Columns[3].Width =
                dataGridView1.Columns[4].Width = 35;

            dataGridView1.Columns[_JAP].AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells;
            dataGridView1.Columns[_ENG].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;

            for (int c = 0; c < columns.Length; c++)
            {
                dataGridView1.Columns[c].ReadOnly = true;
            }

            dataGridView1.Columns[_JAP].ReadOnly = false;
            dataGridView1.Columns[_ENG].ReadOnly = false;


            dataGridView1.CellValuePushed +=
                new DataGridViewCellValueEventHandler(dataGridView1_CellValuePushed);
            dataGridView1.CellValueNeeded +=
               new DataGridViewCellValueEventHandler(dataGridView1_CellValueNeeded);
          
            dataGridView1.KeyDown += new KeyEventHandler(dataGridView1_KeyDown);

            dataGridView2.Columns.Add("FILE", "FILE");
            dataGridView2.Columns.Add("TITLE", "TITLE");

            dataGridView2.Columns[0].Width = 60;
            dataGridView2.Columns[1].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;

            dataGridView2.CellValueNeeded += new DataGridViewCellValueEventHandler(dataGridView2_CellValueNeeded);
            dataGridView2.CellClick += new DataGridViewCellEventHandler(dataGridView2_CellClick);
        


            this.Shown += new EventHandler(Form1_Shown);

            if (File.Exists(name_set))
            {
                ss = load() as cls_save;
                if (ss == null) { ss = new cls_save(); }


                cbox_hyphen.Checked = ss.add_hyphen;
                this.WindowState = ss.fws;
                if (ss.fws == FormWindowState.Normal)
                {
                    this.Bounds = ss.rec;
                }               

                if (File.Exists(ss.last_open))
                {
                    get_files(Path.GetDirectoryName(ss.last_open));
                }
            }

            this.FormClosing += delegate(object sender, FormClosingEventArgs e)
            {
                cls_save ss = new cls_save();

                ss.fws = this.WindowState;
                if (ss.fws == FormWindowState.Minimized)
                {
                    ss.fws = FormWindowState.Normal;
                }

                if (current_file != "")
                {
                    ss.last_open = current_file;
                }

                ss.rec = this.Bounds;
                ss.add_hyphen = cbox_hyphen.Checked;
                save(ss);

                if (!checkSave())
                {
                    e.Cancel = true;
                }
            };
        }
        cls_save ss = null;
        void Form1_Shown(object sender, EventArgs e)
        {
            dataGridView2.CurrentCellChanged += new EventHandler(dataGridView2_CurrentCellChanged);

            if (ss.last_open!= "" && File.Exists(ss.last_open))
            {
                for (int c = 0; c < map_files.Count;c++ )
                {
                    if (map_files[c].path == ss.last_open)
                    {
                        dataGridView2.CurrentCell = dataGridView2[1, c];
                        break;
                    }
                }
            }                    
        }

        void dataGridView1_KeyDown(object sender, KeyEventArgs e)
        {
            if (dataGridView1.CurrentCell.ColumnIndex != _ENG)
            {
                return;
            }

            if (e.KeyCode == Keys.Delete)
            {
                g_texts[dataGridView1.CurrentRow.Index].text_replace = "";
                dataGridView1.Refresh();
            }
            else if ((e.Modifiers & Keys.Control) == Keys.Control && e.KeyCode == Keys.V)
            {
                String clipText = Clipboard.GetText();
                clipText = clipText.Replace("\r\n", "");
                clipText = clipText.Replace("\r", "");
                g_texts[dataGridView1.CurrentRow.Index].text_replace = clipText;
                dataGridView1.Refresh();
            }
        }

        [Serializable()]
        class cls_save
        {
            internal Rectangle rec = Rectangle.Empty;
            internal FormWindowState fws = FormWindowState.Normal;
            internal string last_open = "";
            internal bool add_hyphen = false;
        }     

        void dataGridView2_CurrentCellChanged(object sender, EventArgs e)
        {
            if (dataGridView2.CurrentRow.Index < 0) { return; }

            parse_map_data(dataGridView2.CurrentRow.Index);
        }

        void dataGridView1_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            if (e.ColumnIndex == _ID)
            {
                byte val = g_texts[e.RowIndex].id;
                if (val == 0)
                {
                    if (g_texts[e.RowIndex].IsHeader)
                    {                       
                        e.CellStyle.BackColor = Color.Orange;
                    }
                    else
                    {
                        e.CellStyle.BackColor = Color.LightBlue;//data border
                    }
                }
                else if (val == 0x62)
                {
                    e.CellStyle.BackColor = Color.Green;
                }
                else
                {
                    e.CellStyle.BackColor = Color.White;
                }
            }
        }

        void dataGridView2_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.ColumnIndex < 0 || e.RowIndex < 0) { return; }

            parse_map_data(e.RowIndex);
        }

        void dataGridView2_CellValueNeeded(object sender, DataGridViewCellValueEventArgs e)
        {
            if (e.ColumnIndex < 0 || e.RowIndex < 0) { return; }


            switch (e.ColumnIndex)
            {
                case 0:
                    e.Value = map_files[e.RowIndex].fileName;
                    break;
                case 1:
                    e.Value = map_files[e.RowIndex].title;
                    break;
            }
        }
        
        void dataGridView1_CellValuePushed(object sender, DataGridViewCellValueEventArgs e)
        {
            if (e.ColumnIndex < 0 || e.RowIndex < 0) { return; }


            switch (e.ColumnIndex)
            {
                case _ENG:

                    if (e.Value == null)
                    {
                        g_texts[e.RowIndex].text_replace = "";
                    }
                    else
                    {
                        g_texts[e.RowIndex].text_replace = e.Value.ToString();
                    }

                    break;
            }
        }

        void dataGridView1_CellValueNeeded(object sender, DataGridViewCellValueEventArgs e)
        {
            if (e.ColumnIndex < 0 || e.RowIndex < 0) { return; }

            switch (e.ColumnIndex)
            {
                case 0:
                    e.Value = g_texts[e.RowIndex].position.ToString("X");
                    break;
                case 1:
                    if (g_texts[e.RowIndex].header != null)
                    {
                        e.Value = string.Format("{0:000}:{1:000}",
                            g_texts[e.RowIndex].header._x02_X,
                            g_texts[e.RowIndex].header._x03_Y                                
                            );
                    }
                    break;
                case 2:
                    e.Value = g_texts[e.RowIndex].id.ToString("X");
                    break;
                case 3:
                    e.Value = g_texts[e.RowIndex].id2.ToString("X");
                    break;
                case 4:
                    e.Value = g_texts[e.RowIndex].len.ToString();
                    break;

                case _JAP:

                    if (g_texts[e.RowIndex].IsHeader)
                    {
                        e.Value = string.Format("OFF8: ({0}) 通し番号: ({1})",
                            g_texts[e.RowIndex].header._x07_unkown.ToString("X").PadLeft(2, '0'),
                            g_texts[e.RowIndex].header._x16_SeqNum.ToString().PadLeft(2, '0')
                            );
                    }
                    else
                    {
                        e.Value = g_texts[e.RowIndex].text_source;
                    }                  
                    break;
                case _ENG:
                    e.Value = g_texts[e.RowIndex].text_replace;
                    break;
            }
        }
        




        bool checkSave()
        {
            if (current_file != "")
            {
                if (check_texts())
                {
                    DialogResult dr = MessageBox.Show("save?", "", MessageBoxButtons.YesNoCancel);
                    if (dr == System.Windows.Forms.DialogResult.Yes)
                    {
                        btnFlush_Click(null, null);
                    }
                    else if (dr == System.Windows.Forms.DialogResult.Cancel)
                    {
                        return false;
                    }
                }
            }

            return true;
        }
        bool check_texts()
        {
            int count_edited = 0;
            foreach (var va in g_texts)
            {
                if (va.text_replace != "")
                {
                    count_edited++;
                }
            }

            if (count_edited == 0)
            {
                return false;
            }

            return true;
        }


        const int OFF_029 = 0x29;
        const int OFF_03C = 0x3C;
        const int OFF_04F = 0x4F;
        const int OFF_062 = 0x62;

        int[] OFFs = new int[] { 0x29, 0x3C, 0x4F, 0x62 };
        int g_off_header = 0;
        int g_start = -1;

        bool check_letter(char ch)
        {
            if ((('A' <= ch) && (ch <= 'Z')) ||
                 (('a' <= ch) && (ch <= 'z')))
            {
                return true;
            }

            return false;

        }

        void parse_map_data(int index)
        {
            checkSave();

            this.Text = "Dante98_2 Editor:" + map_files[index].fileName + " [" + map_files[index].title + "]";
            parse_map_data(map_files[index].path);
        }
        
        void parse_map_data(string path)
        {
            dataGridView1.RowCount = 0;
            g_texts.Clear();
            g_headers = null;

            current_file = path;
            byte[] bits = File.ReadAllBytes(path);
            g_bits = bits;

            int position = 0;
            g_start = -1;
            g_off_header = -1;

            try
            {
                while (true)
                {
                    if (bits[position] == 0xFF &&
                        bits[position + 1] == 0xFF &&
                        bits[position + 2] == 0xFF &&
                        bits[position + 3] == 0xFF &&
                        bits[position + 4] == 0x62)
                    {
                        g_start = position + 4;
                        g_off_header = g_start - 0x1F4;
                        break;
                    }
                    position += 0x10;
                }
            }
            catch
            {
                g_start = -1;
            }

            if (g_start == -1)
            {
                return;
            }


            int MAX_EVENT = 248;
            List<ushort> e_header_offsets = new List<ushort>();

            
            try
            {
                for (int c = 0; c < MAX_EVENT; c++)
                {
                    e_header_offsets.Add(get_ushort(g_off_header + (c * 2)));
                }
            }
            catch
            {
                e_header_offsets = null;
            }

          

            int count = 0;
            g_headers = new cls_Header[MAX_EVENT];

            try
            {

                for (int ss = 0; ss < e_header_offsets.Count; ss++)
                {
                    ushort off = e_header_offsets[ss];
                    if (off == 0xFFFF)
                    {
                        continue;//未使用のイベント
                    }
                    count++;

                    position = (off + g_start) - 2;                   

                    if (bits[position] != 0x62)
                    {
                        MessageBox.Show("header ID is not 0x62");
                        return;
                    }

                    cls_Header header = new cls_Header();
                    header.IsHeader = true;
                    header.position = position;
                    header._x02_X = bits[position + 2];
                    header._x03_Y = bits[position + 3];

                    header._x16_SeqNum = bits[position + 0x16];
                    if (ss != header._x16_SeqNum)
                    {
                        MessageBox.Show("header number is not matched");
                        return;
                    }

                    header.off_data[0] = get_ushort(position + OFF_029);
                    header.off_data[1] = get_ushort(position + OFF_03C);
                    header.off_data[2] = get_ushort(position + OFF_04F);
                    header.off_data[3] = get_ushort(position + OFF_062);

                    for (int c = 0; c < 4; c++)
                    {
                        int temp = g_start + header.off_data[c] - 2;
                        header.size_data[c] = get_ushort(temp);
                    }

                    header.data = new byte[0x64];
                    for (byte c = 0; c < header.data.Length; c++)
                    {
                        header.data[c] = (bits[position + c]);
                    }
                    g_headers[ss] = (header);
                }            
            }
            catch(Exception exc)
            {
                MessageBox.Show(exc.Message);
            }

            Array.Sort(g_headers,compa);

        
            int sum_total = 0;
            for (int c = 0; c < g_headers.Length - 1; c++)
            {
                if (g_headers[c] == null)
                {
                    break;
                }

                cls_Header cls = g_headers[c];       
                int off_next = 0;

                if (g_headers[c + 1] == null)
                {
                    off_next = bits.Length;
                }
                else
                {
                    off_next = g_headers[c + 1].position;
                }

                int sub = off_next - cls.position;

                int size = 0x64 + (4 * 2) +
                     cls.size_data[0] + cls.size_data[1] + cls.size_data[2] +
                     cls.size_data[3];

                if (size != sub)
                {
                    MessageBox.Show("error sub");
                }

                cls.total_size = size;

                sum_total += size;
            }           

            int SIZE = get_ushort(g_off_header - 2);
            if (sum_total != SIZE)
            {
                MessageBox.Show("error sum_total is not matched");
            }        


            try
            {
                for (int c = 0; c < g_headers.Length; c++)
                {
                    if (g_headers[c] == null)
                    {
                        break;
                    }

                    cls_Header header = g_headers[c];

                    for (int r = 0; r < 4; r++)
                    {
                        header.datas[r] = new List<cls_Data>();
                        get_data(header.datas[r], g_start + header.off_data[r], header);

                        int size_test = get_total(header.datas[r]);

                        if (size_test != header.size_data[r])
                        {
                            MessageBox.Show("size_test failed");
                        }
                    }
                }
            }
            catch(Exception exc)
            {
                MessageBox.Show(exc.Message);
            }          

            dataGridView1.RowCount = g_texts.Count;

            Color col = Color.WhiteSmoke;
            for (int r = 0; r < g_texts.Count; r++)
            {
                if (g_texts[r].id == 0x65)
                {
                    if (g_texts[r - 1].id == 1)
                    {
                        col = (col == Color.WhiteSmoke) ? SystemColors.ControlLight : Color.WhiteSmoke;
                        dataGridView1.Rows[r - 1].DefaultCellStyle.BackColor = col;
                    }
                    dataGridView1.Rows[r].DefaultCellStyle.BackColor = col;
                }            
            }
        }


        ushort get_total(List<cls_Data> data)
        {
            ushort header_size = 3;

            ushort size_test = 0;
            foreach (cls_Data cls in data)
            {
                ushort temp = (ushort)(header_size + (ushort)cls.len);
                size_test += temp;
            }
            size_test += 1;

            return size_test;
        }


        void get_data(List<cls_Data> datas, int position, cls_Header header)
        {
            while (true)
            {
                cls_Data cls = new cls_Data();
                cls.header = header;
                cls.position = position;
                cls.id = g_bits[position];

                if (cls.id == 0)
                {
                    break;
                }

                cls.len = g_bits[position + 1];
                cls.id2 = g_bits[position + 2];

                position += 3;

                cls.data = new byte[cls.len];
                for (byte c = 0; c < cls.data.Length; c++)
                {
                    cls.data[c] = (g_bits[position + c]);
                }

                position += cls.len;

                if ((cls.id == 1 || cls.id == 0x65))
                {
                    cls.text_source = sjis.GetString(cls.data);
                    cls.IsText = true;
                    g_texts.Add(cls);
                }

                datas.Add(cls);
            }
        }

       
        
        private void btnFlush_Click(object sender, EventArgs e)
        {
            if (current_file == "")
            {
                MessageBox.Show("no selected file");
                return;
            }

            if (g_texts.Count == 0)
            {
                MessageBox.Show("no texts");
                return;
            }

            if (!check_texts())
            {
                MessageBox.Show("no edited texts");
                return;
            }          

            FileStream fs = null;
            try
            {
                fs = new FileStream(current_file, FileMode.Open, FileAccess.ReadWrite);
                fs.Close();
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
                return;
            }          

            try
            {
                MemoryStream ms = new MemoryStream();
                int total_offset = 0;

                for (int c = 0; c < g_headers.Length; c++)
                {
                    if (g_headers[c] == null)
                    {
                        break;
                    }

                    cls_Header header = g_headers[c];

                    ms.Write(header.data, 0, 0x64);

                    ushort[] offs = new ushort[4];

                    for (int r = 0; r < 4; r++)
                    {
                        MemoryStream msData = new MemoryStream();

                        for (int ZZZ = 0; ZZZ < header.datas[r].Count; ZZZ++)
                        {
                            cls_Data cls = header.datas[r][ZZZ];

                            if (cls.IsText && cls.text_replace != "")
                            {
                                List<List<byte>> rrr = new List<List<byte>>();

                                List<byte> sss = new List<byte>();

                                for (int t = 0; t < cls.text_replace.Length; t++)
                                {
                                    sss.AddRange(sjis.GetBytes(cls.text_replace[t].ToString()));

                                    if (sss.Count > MAX_TEXT_LENGTH)
                                    {
                                        if (cbox_hyphen.Checked &&
                                            t + 1 < cls.text_replace.Length)
                                        {
                                            if (check_letter(cls.text_replace[t]) &&
                                                check_letter(cls.text_replace[t + 1]))
                                            {
                                                sss.AddRange(sjis.GetBytes("-"));
                                            }
                                        }

                                        rrr.Add(sss);
                                        sss = new List<byte>();
                                    }
                                }

                                if (sss.Count > 0)
                                {
                                    rrr.Add(sss);
                                }

                                int current_row = 1;
                                if (cls.id == 0x65)
                                {
                                    current_row = 2;
                                    int ccc = ZZZ - 1;
                                    while (true)
                                    {
                                        if (header.datas[r][ccc].id == 1)
                                        {
                                            break;
                                        }
                                        current_row++;
                                        ccc--;
                                    }
                                }


                                for (int xxx = 0; xxx < rrr.Count; xxx++)
                                {
                                    byte[] xxxx = rrr[xxx].ToArray();

                                    byte ID = 1;
                                    if (current_row == 5)
                                    {
                                        ID = 1;
                                        current_row = 1;
                                    }
                                    else if (current_row == 1)
                                    {
                                        ID = 1;
                                    }
                                    else
                                    {
                                        ID = 0x65;
                                    }

                                    msData.WriteByte(ID);
                                    cls.len = (byte)xxxx.Length;
                                    msData.WriteByte(cls.len);
                                    msData.WriteByte(cls.id2);
                                    msData.Write(xxxx, 0, cls.len);

                                    current_row++;
                                }

                                cls.text_replace = "";

                           
                                int rest = 5 - current_row;
                                if (rest < 3)//
                                {
                                    for (int ee = 1; ee <= 3; ee++)//
                                    {
                                        if (ee + ZZZ < header.datas[r].Count)
                                        {
                                            if (header.datas[r][ee + ZZZ].id == 0x65)
                                            {
                                                if (rest == 0)
                                                {
                                                    header.datas[r][ee + ZZZ].id = 1;//
                                                    break;//終了
                                                }
                                                rest--;
                                            }
                                        }
                                    }
                                }
                            }
                            else
                            {
                                msData.WriteByte(cls.id);
                                msData.WriteByte(cls.len);
                                msData.WriteByte(cls.id2);
                                msData.Write(cls.data, 0, cls.len);
                            }
                        }

                        msData.WriteByte(0);//

                        msData.Capacity = (int)msData.Length;
                        header.size_data[r] = (ushort)msData.Length;

                        ms.Write(BitConverter.GetBytes(header.size_data[r]), 0, 2);
                        offs[r] = (ushort)ms.Position;//
                        ms.Write(msData.GetBuffer(), 0, header.size_data[r]);//
                    }

                    long tempPosi = ms.Position;     

                    for (int r = 0; r < 4; r++)
                    {
                        ms.Position = total_offset + OFFs[r];
                        ms.Write(BitConverter.GetBytes(offs[r]), 0, 2);
                    }

                    ms.Position = tempPosi;

                    header.total_size = (int)ms.Position - total_offset;
                    header.position = total_offset;
                    total_offset += header.total_size;
                }

                ushort total_len = (ushort)ms.Length;
                ms.Capacity = total_len;



                MemoryStream msSt = new MemoryStream();
                for (int z = 0; z < g_start; z++)
                {
                    msSt.WriteByte(g_bits[z]);
                }

                long before = msSt.Position;

             
                for (int c = 0; c < g_headers.Length; c++)
                {
                    if (g_headers[c] == null)
                    {
                        break;
                    }

                    msSt.Position = g_off_header + (g_headers[c]._x16_SeqNum * 2);
                    ushort off = (ushort)g_headers[c].position;
                    off += 2;

                    msSt.Write(BitConverter.GetBytes(off), 0, 2);
                }

                msSt.Position = before;


                before = msSt.Position;
                msSt.Position = g_off_header - 2;
                msSt.Write(BitConverter.GetBytes(total_len), 0, 2);               

                msSt.Position = before;
                msSt.Write(ms.GetBuffer(), 0, total_len);



                msSt.Capacity = (int)msSt.Length;//仕上げ
                File.WriteAllBytes("sss.bin", msSt.GetBuffer());


                if (File.Exists(current_file))
                {
                    File.Delete(current_file);
                }
                File.WriteAllBytes(current_file, msSt.GetBuffer());
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
                return;
            }

            MessageBox.Show("file saved\n" + current_file);

            if (e != null)
            {
                parse_map_data(current_file);
            }
        }


        private void btnExtract_Click(object sender, EventArgs e)
        {
            if (map_files.Count == 0)
            {
                return;
            }
         
        }



        void test2()
        {
           

        }

        private void button1_Click(object sender, EventArgs e)
        {
           

        }

    }




   
}
